package co.yixiang.yshop.module.order.service.rechargeorder;

import java.util.*;
import javax.validation.*;

import co.yixiang.yshop.module.order.controller.admin.rechargeorder.vo.*;
import co.yixiang.yshop.module.order.dal.dataobject.rechargeorder.RechargeOrderDO;
import co.yixiang.yshop.framework.common.pojo.PageResult;

/**
 * 充值订单 Service 接口
 *
 * @author admin
 */
public interface RechargeOrderService {

    /**
     * 创建充值订单
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    String createRechargeOrder(@Valid RechargeOrderCreateReqVO createReqVO);

    /**
     * 更新充值订单
     *
     * @param updateReqVO 更新信息
     */
    void updateRechargeOrder(@Valid RechargeOrderUpdateReqVO updateReqVO);

    /**
     * 删除充值订单
     *
     * @param id 编号
     */
    void deleteRechargeOrder(String id);

    /**
     * 获得充值订单
     *
     * @param id 编号
     * @return 充值订单
     */
    RechargeOrderDO getRechargeOrder(String id);

    /**
     * 获得充值订单列表
     *
     * @param ids 编号
     * @return 充值订单列表
     */
    List<RechargeOrderDO> getRechargeOrderList(Collection<String> ids);

    /**
     * 获得充值订单分页
     *
     * @param pageReqVO 分页查询
     * @return 充值订单分页
     */
    PageResult<RechargeOrderRespVO> getRechargeOrderPage(RechargeOrderPageReqVO pageReqVO);

    /**
     * 获得充值订单列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 充值订单列表
     */
    List<RechargeOrderDO> getRechargeOrderList(RechargeOrderExportReqVO exportReqVO);

    void refund() throws Exception;

}
